VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_get_shortcut_info"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7725
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   7725
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtArguments 
      Height          =   285
      Left            =   1560
      TabIndex        =   11
      Top             =   2640
      Width           =   3735
   End
   Begin VB.TextBox txtWorkingDirectory 
      Height          =   285
      Left            =   1560
      TabIndex        =   9
      Top             =   2280
      Width           =   3735
   End
   Begin VB.TextBox txtPath 
      Height          =   285
      Left            =   1560
      TabIndex        =   7
      Top             =   1920
      Width           =   3735
   End
   Begin VB.TextBox txtDescription 
      Height          =   285
      Left            =   1560
      TabIndex        =   5
      Top             =   1560
      Width           =   3735
   End
   Begin VB.TextBox txtName 
      Height          =   285
      Left            =   1560
      TabIndex        =   3
      Top             =   1200
      Width           =   3735
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Height          =   375
      Left            =   3240
      TabIndex        =   2
      Top             =   600
      Width           =   975
   End
   Begin VB.TextBox txtShortcut 
      Height          =   285
      Left            =   1560
      TabIndex        =   1
      Text            =   "C:\Documents and Settings\Rod\Desktop\Microsoft Visual Basic 6.0"
      Top             =   120
      Width           =   3735
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Arguments:"
      Height          =   195
      Index           =   5
      Left            =   120
      TabIndex        =   12
      Top             =   2640
      Width           =   795
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Working Directory:"
      Height          =   195
      Index           =   4
      Left            =   120
      TabIndex        =   10
      Top             =   2280
      Width           =   1320
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Path"
      Height          =   195
      Index           =   3
      Left            =   120
      TabIndex        =   8
      Top             =   1920
      Width           =   330
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Description:"
      Height          =   195
      Index           =   2
      Left            =   120
      TabIndex        =   6
      Top             =   1560
      Width           =   840
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Name:"
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   465
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Shortcut:"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   645
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Add a reference to the COM library "Microsoft Shell Controls and Automation."

Private Sub cmdGo_Click()
Dim name As String
Dim descr As String
Dim path As String
Dim working_dir As String
Dim args As String
Dim result As String

    result = _
        GetShortcutInfo(txtShortcut.Text, name, path, descr, working_dir, args)

    If Len(result) > 0 Then
        MsgBox result, vbOKOnly Or vbExclamation, "Error"
    Else
        txtName.Text = name
        txtDescription.Text = descr
        txtPath.Text = path
        txtWorkingDirectory.Text = working_dir
        txtArguments.Text = args
    End If
End Sub

' Get information about this link.
' Return an error message if there's a problem.
Private Function GetShortcutInfo(ByVal full_name As String, ByRef name As String, ByRef path As String, ByVal descr As String, ByRef working_dir As String, ByRef args As String) As String
Dim shl As Shell32.Shell
Dim shortcut_path, shortcut_name As String
Dim shortcut_folder As Shell32.Folder
Dim folder_item As Shell32.FolderItem
Dim lnk As Shell32.ShellLinkObject

    On Error GoTo GetShortcutInfoError

    ' Make a Shell object.
    Set shl = New Shell32.Shell

    ' Get the shortcut's folder and name.
    shortcut_path = Left$(full_name, InStrRev(full_name, "\"))
    shortcut_name = Mid$(full_name, InStrRev(full_name, "\") + 1)
    If Not Right$(shortcut_name, 4) = ".lnk" Then shortcut_name = shortcut_name & ".lnk"

    ' Get the shortcut's folder.
    Set shortcut_folder = shl.NameSpace(shortcut_path)

    ' Get the shortcut's file.
    Set folder_item = shortcut_folder.Items.Item(shortcut_name)
    If folder_item Is Nothing Then
        GetShortcutInfo = "Cannot find shortcut file '" & full_name & "'"
    ElseIf Not folder_item.IsLink Then
        ' It's not a link.
        GetShortcutInfo = "File '" & full_name & "' isn't a shortcut."
    Else
        ' Display the shortcut's information.
        Set lnk = folder_item.GetLink
        name = folder_item.name
        descr = lnk.Description
        path = lnk.path
        working_dir = lnk.WorkingDirectory
        args = lnk.Arguments
        GetShortcutInfo = ""
    End If
    Exit Function

GetShortcutInfoError:
    GetShortcutInfo = Err.Description
End Function

Private Sub Form_Resize()
Dim wid As Single
Dim ctl As Control

    wid = ScaleWidth - txtShortcut.Left - 120
    If wid < 120 Then wid = 120
    For Each ctl In Controls
        If TypeOf ctl Is TextBox Then ctl.Width = wid
    Next ctl

    cmdGo.Left = (ScaleWidth - cmdGo.Width) / 2
End Sub
